diff -urN simple-ldap-login/Simple-LDAP-Login-Admin.php simple-ldap-login.new/Simple-LDAP-Login-Admin.php
--- simple-ldap-login/Simple-LDAP-Login-Admin.php	2011-12-08 21:52:12.000000000 -0600
+++ simple-ldap-login.new/Simple-LDAP-Login-Admin.php	2012-02-13 15:51:20.000000000 -0600
@@ -76,29 +76,29 @@
 //If admin options updated (uses hidden field)
 if ($_POST['stage'] == 'process') 
 {
-    update_option('simpleldap_account_suffix', $_POST['account_suffix']);
-	update_option('simpleldap_base_dn', $_POST['base_dn']);
-	update_option('simpleldap_domain_controllers', $_POST['domain_controller']);
+	update_site_option('simpleldap_account_suffix', $_POST['account_suffix']);
+	update_site_option('simpleldap_base_dn', $_POST['base_dn']);
+	update_site_option('simpleldap_domain_controllers', $_POST['domain_controller']);
 
 	//Version 1.3
-	update_option('simpleldap_directory_type',$_POST['LDAP']);
-	update_option('simpleldap_login_mode',$_POST['mode']);
-	update_option('simpleldap_group',$_POST['group_name']);
-	update_option('simpleldap_account_type',$_POST['create_type']);
+	update_site_option('simpleldap_directory_type',$_POST['LDAP']);
+	update_site_option('simpleldap_login_mode',$_POST['mode']);
+	update_site_option('simpleldap_group',$_POST['group_name']);
+	update_site_option('simpleldap_account_type',$_POST['create_type']);
 	
 	//Version 1.3.0.2
-	update_option('simpleldap_security_mode',$_POST['security_mode']);
+	update_site_option('simpleldap_security_mode',$_POST['security_mode']);
 	
 	//Version 1.4
-	update_option('simpleldap_ol_login', $_POST['ol_login']);
+	update_site_option('simpleldap_ol_login', $_POST['ol_login']);
 	
 	if(isset($_POST['use_tls']))
 	{
-		update_option("simpleldap_use_tls", $_POST['use_tls']);
+		update_site_option("simpleldap_use_tls", $_POST['use_tls']);
 	}
 	else
 	{
-		update_option("simpleldap_use_tls", "no");
+		update_site_option("simpleldap_use_tls", "no");
 	}
 	
 }
@@ -108,13 +108,13 @@
 	global $bool_test;
 	
 	//Temporarily change security mode for test. Store old setting.
-	$temp_holder = get_option("simpleldap_security_mode");
-	update_option("simpleldap_security_mode", "security_high");
+	$temp_holder = get_site_option("simpleldap_security_mode");
+	update_site_option("simpleldap_security_mode", "security_high");
 	
 	$test_user = wp_authenticate($_POST['test_username'],$_POST['test_password']);
 	
 	//Restore security mode setting.
-	update_option("simpleldap_security_mode", $temp_holder);
+	update_site_option("simpleldap_security_mode", $temp_holder);
 	
 	if ($test_user->ID > 0)
 	{
@@ -126,22 +126,22 @@
 	}
 }
 //Load settings, etc
-$simpleldap_account_suffix = get_option("simpleldap_account_suffix");
-$simpleldap_base_dn = get_option("simpleldap_base_dn");
-$simpleldap_domain_controllers = get_option("simpleldap_domain_controllers");
+$simpleldap_account_suffix = get_site_option("simpleldap_account_suffix");
+$simpleldap_base_dn = get_site_option("simpleldap_base_dn");
+$simpleldap_domain_controllers = get_site_option("simpleldap_domain_controllers");
 
 //Version 1.3
-$simpleldap_directory_type = 	get_option("simpleldap_directory_type");
-$simpleldap_login_mode = 	get_option("simpleldap_login_mode");
-$simpleldap_group = 	get_option("simpleldap_group");
-$simpleldap_account_type = 	get_option("simpleldap_account_type");
+$simpleldap_directory_type = 	get_site_option("simpleldap_directory_type");
+$simpleldap_login_mode = 	get_site_option("simpleldap_login_mode");
+$simpleldap_group = 	get_site_option("simpleldap_group");
+$simpleldap_account_type = 	get_site_option("simpleldap_account_type");
 
 //Version 1.3.0.2
-$simpleldap_security_mode = get_option("simpleldap_security_mode");
+$simpleldap_security_mode = get_site_option("simpleldap_security_mode");
 
 //Version 1.4
-$simpleldap_ol_login = get_option("simpleldap_ol_login");
-$simpleldap_use_tls = get_option("simpleldap_use_tls");
+$simpleldap_ol_login = get_site_option("simpleldap_ol_login");
+$simpleldap_use_tls = get_site_option("simpleldap_use_tls");
 
 ?>
 <body>
@@ -241,11 +241,11 @@
 if($debug == "true")
 {
 echo "<p style=\"clear:both;\">Debug Info:<br/>";
-echo "simpleldap_directory_type: ".get_option("simpleldap_directory_type")."/".$_POST['LDAP']."<br/>";
-echo "simpleldap_login_mode: ".get_option("simpleldap_login_mode")."/".$_POST['mode']."<br/>";
-echo "simpleldap_group: ".get_option("simpleldap_group")."/".$_POST['group_name']."<br/>";
-echo "simpleldap_account_type: ".get_option("simpleldap_account_type")."/".$_POST['create_type']."<br/></p>";
+echo "simpleldap_directory_type: ".get_site_option("simpleldap_directory_type")."/".$_POST['LDAP']."<br/>";
+echo "simpleldap_login_mode: ".get_site_option("simpleldap_login_mode")."/".$_POST['mode']."<br/>";
+echo "simpleldap_group: ".get_site_option("simpleldap_group")."/".$_POST['group_name']."<br/>";
+echo "simpleldap_account_type: ".get_site_option("simpleldap_account_type")."/".$_POST['create_type']."<br/></p>";
 }
 ?>
 </body>
-</html>
\ No newline at end of file
+</html>
diff -urN simple-ldap-login/Simple-LDAP-Login.php simple-ldap-login.new/Simple-LDAP-Login.php
--- simple-ldap-login/Simple-LDAP-Login.php	2011-12-08 21:52:12.000000000 -0600
+++ simple-ldap-login.new/Simple-LDAP-Login.php	2012-02-13 16:29:18.000000000 -0600
@@ -7,8 +7,7 @@
 Author: Clifton H. Griffin II
 Author URI: http://clifgriffin.com
 */
-require_once( WP_PLUGIN_DIR."/simple-ldap-login/adLDAP.php");
-require_once( ABSPATH . WPINC . '/registration.php');
+require_once(plugin_dir_path(__FILE__)."adLDAP.php");
 
 //Admin
 function simpleldap_menu()
@@ -18,43 +17,47 @@
 
 function simpleldap_admin_actions()
 {
-    add_options_page("Simple LDAP Login", "Simple LDAP Login", 10, "simple-ldap-login", "simpleldap_menu");
+	if (function_exists('is_multisite') && is_multisite())
+		add_submenu_page("settings.php", "Simple LDAP Login", "Simple LDAP Login", "manage_network_options", "simple-ldap-login", "simpleldap_menu");
+	else
+		add_options_page("Simple LDAP Login", "Simple LDAP Login", "manage_options", "simple-ldap-login", "simpleldap_menu");
 }
+
 function simpleldap_activation_hook()
 {
 	//Store settings
-	add_option("simpleldap_account_suffix", "@mydomain.local");
-	add_option("simpleldap_base_dn", "DC=mydomain,DC=local");
-	add_option("simpleldap_domain_controllers", "dc01.mydomain.local");
-	
+	add_site_option("simpleldap_account_suffix", "@mydomain.local");
+	add_site_option("simpleldap_base_dn", "DC=mydomain,DC=local");
+	add_site_option("simpleldap_domain_controllers", "dc01.mydomain.local");
+
 	//Version 1.3
-	add_option("simpleldap_directory_type", "directory_ad");
-	add_option("simpleldap_login_mode", "mode_normal");
-	add_option("simpleldap_group", "");
-	add_option("simpleldap_account_type", "Contributor");
-	
+	add_site_option("simpleldap_directory_type", "directory_ad");
+	add_site_option("simpleldap_login_mode", "mode_normal");
+	add_site_option("simpleldap_group", "");
+	add_site_option("simpleldap_account_type", "Contributor");
+
 	//Version 1.3.0.2
-	add_option("simpleldap_security_mode", "security_low");
-	
+	add_site_option("simpleldap_security_mode", "security_low");
+
 	//Version 1.4
-	add_option("simpleldap_ol_login", "uid");
-	add_option("simpleldap_use_tls", "no");
+	add_site_option("simpleldap_ol_login", "uid");
+	add_site_option("simpleldap_use_tls", "no");
 }
 
 //For adLDAP
 $sll_use_tls = false;
-if(get_option("simpleldap_use_tls") == "yes") {
+if (get_site_option("simpleldap_use_tls") == "yes"){
 	$sll_use_tls = true;
 }
 $sll_options=array(
-	"account_suffix"=>get_option("simpleldap_account_suffix"),
+	"account_suffix"=>get_site_option("simpleldap_account_suffix"),
 	"use_tls"=>$sll_use_tls,
-	"base_dn"=>get_option("simpleldap_base_dn"),
-	"domain_controllers"=>explode(";",get_option("simpleldap_domain_controllers")),	
+	"base_dn"=>get_site_option("simpleldap_base_dn"),
+	"domain_controllers"=>explode(";",get_site_option("simpleldap_domain_controllers")),	
 );
 
 //For OpenLDAP
-$ar_ldaphosts = explode(";",get_option("simpleldap_domain_controllers"));
+$ar_ldaphosts = explode(";",get_site_option("simpleldap_domain_controllers"));
 $ldaphosts = ""; //string to hold each host separated by space
 $ldap = null;
 $adldap = new adLDAP($sll_options);
@@ -65,11 +68,14 @@
 define ('LDAP_HOST', $ldaphosts);
 define ('LDAP_PORT', 389);
 define ('LDAP_VERSION', 3);
-define ('BASE_DN', get_option('simpleldap_base_dn'));
-define ('LOGIN', get_option("simpleldap_ol_login"));
+define ('BASE_DN', get_site_option('simpleldap_base_dn'));
+define ('LOGIN', get_site_option("simpleldap_ol_login"));
 
 //Add the menu
-add_action('admin_menu', 'simpleldap_admin_actions');
+if (function_exists('is_multisite') && is_multisite())
+	add_action('network_admin_menu', 'simpleldap_admin_actions');
+else
+	add_action('admin_menu', 'simpleldap_admin_actions');
 
 //Add filter
 add_filter('authenticate', 'sll_authenticate', 1, 3);
@@ -79,7 +85,7 @@
 	if ( is_a($user, 'WP_User') ) { return $user; }
 	
 	//Failed, should we let it continue to lower priority authenticate methods?
-	if(get_option("simpleldap_security_mode") == "security_high")
+	if(get_site_option("simpleldap_security_mode") == "security_high")
 	{
 		remove_filter('authenticate', 'wp_authenticate_username_password', 20, 3);
 	}
@@ -104,7 +110,7 @@
 			if ( !$user || (strtolower($user->user_login) != strtolower($username)) ) 
 			{
 				//No user, can we create?
-				switch(get_option('simpleldap_login_mode'))
+				switch(get_site_option('simpleldap_login_mode'))
 				{
 					case "mode_create_all":
 						$new_user_id = sll_create_wp_user($username);
@@ -150,7 +156,7 @@
 			else
 			{
 				//Wordpress user exists, should we check group membership?
-				if(get_option('simpleldap_login_mode') == "mode_create_group")
+				if(get_site_option('simpleldap_login_mode') == "mode_create_group")
 				{
 					if(sll_is_in_group($username))
 					{
@@ -187,7 +193,7 @@
 	global $ldap, $adldap;
 	
 	$result = false;
-	switch(get_option('simpleldap_directory_type'))
+	switch(get_site_option('simpleldap_directory_type'))
 	{
 		case "directory_ad":
 			$result = $adldap->authenticate($username,$password);
@@ -200,7 +206,7 @@
 		case "directory_ol":
 			$ldap = ldap_connect(LDAP_HOST, LDAP_PORT) or die("Can't connect to LDAP server.");
 			ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, LDAP_VERSION);
-			if (get_option("simpleldap_use_tls") == "yes") {
+			if (get_site_option("simpleldap_use_tls") == "yes") {
 				ldap_start_tls($ldap);
 			}
 			$ldapbind = @ldap_bind($ldap, LOGIN .'=' . $username . ',' . BASE_DN, $password);
@@ -215,10 +221,10 @@
 	global $ldap, $adldap;
 	$result = false;
 	
-	switch(get_option('simpleldap_directory_type'))
+	switch(get_site_option('simpleldap_directory_type'))
 	{
 		case "directory_ad":
-			$result = $adldap->user_ingroup($username,get_option('simpleldap_group'));
+			$result = $adldap->user_ingroup($username,get_site_option('simpleldap_group'));
 		break;
 		
 		case "directory_ol":
@@ -232,7 +238,7 @@
 			for ($i=0; $i<$ldapgroups['count']; $i++) {
 				$groups[] .= $ldapgroups[$i]['cn'][0];
 			}
-			$result = in_array(get_option('simpleldap_group'),$groups);	
+			$result = in_array(get_site_option('simpleldap_group'),$groups);	
 		break;
 	}
 	return $result;
@@ -242,7 +248,7 @@
 	global $ldap, $adldap;
 	$result = 0;
 	
-	switch(get_option('simpleldap_directory_type'))
+	switch(get_site_option('simpleldap_directory_type'))
 	{
 		case "directory_ad":
 			$userinfo = $adldap->user_info($username, array("samaccountname","givenname","sn","mail"));
@@ -255,7 +261,7 @@
 				'display_name'  => $userinfo[0][givenname][0] .' '.$userinfo[0][sn][0],
 				'first_name'    => $userinfo[0][givenname][0],
 				'last_name'     => $userinfo[0][sn][0],
-				'role'			=> strtolower(get_option('simpleldap_account_type'))
+				'role'			=> strtolower(get_site_option('simpleldap_account_type'))
 				);
 				
 			$result = wp_insert_user($userData); 
@@ -276,7 +282,7 @@
 					'display_name'  => $ldapuser[0]['givenname'][0].' '.$ldapuser[0]['sn'][0],
 					'first_name'    => $ldapuser[0]['givenname'][0],
 					'last_name'     => $ldapuser[0]['sn'][0],
-					'role'			=> strtolower(get_option('simpleldap_account_type'))
+					'role'			=> strtolower(get_site_option('simpleldap_account_type'))
 					);
 			
 				//Get ID of new user
